/*================================================================================================*
 * Реализация функций control pipe (GetArray, PutArray и т.п.)
 *================================================================================================*/

#ifndef CTLFUNC_H_
#define CTLFUNC_H_

#include "global.h"
#include "conf.h"

/*================================================================================================*/
/* Адресные пространства LTR для getarray/putarray */
#define CTLFUNC_SEL_AVR_DM            0x82000000
#define CTLFUNC_SEL_AVR_PM            0x83000000
#define CTLFUNC_SEL_FPGA_DATA         0x86000000
#define CTLFUNC_SEL_DSP               0x90000000

/* Размер g_cpld_fpga_info в 16-битных словах */
#define CTLFUNC_FPGA_INFO_LEN   255
/*================================================================================================*/

/*================================================================================================*/
extern uint16_t g_ctlfunc_fpga_info[CTLFUNC_FPGA_INFO_LEN];
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
void ctlfunc_startup(void);
/*------------------------------------------------------------------------------------------------*/
void ctlfunc_reset_fpga(void);
/*------------------------------------------------------------------------------------------------*/
const char* ctlfunc_get_module_name(int* p_size);
/*------------------------------------------------------------------------------------------------*/
int ctlfunc_get_array               /* GET ARRAY */
    (
    conf_iface_t iface,             /* с какого интерфейса обращение */
    uint32_t addr,                  /* адрес чтения */
    size_t len,                     /* длина в байтах */
    uint8_t* dest                   /* данные */
    );                              /* Возвращает bool success */
/*------------------------------------------------------------------------------------------------*/
int ctlfunc_put_array               /* PUT ARRAY */
    (
    conf_iface_t iface,             /* с какого интерфейса обращение */
    uint32_t addr,                  /* адрес чтения */  
    size_t len,                     /* длина в байтах */
    const uint8_t* src              /* данные */        
    );                              /* Возвращает bool success */
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/

#endif /* CTLFUNC_H_ */
